#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.02"

public Plugin:myinfo = 
{
	name = "DoD:S ChooseNade",
	author = "BenSib",
	description = "Rifleman class can choose grenade type!",
	version = PLUGIN_VERSION,
	url = "http://www.dodsplugins.com"
}

new Handle:choosenade = INVALID_HANDLE;
new Handle:choosebonus = INVALID_HANDLE;
new Handle:choosetype = INVALID_HANDLE;
new Handle:choosetime = INVALID_HANDLE;
new Handle:choosesound = INVALID_HANDLE;

new bool:g_gren[MAXPLAYERS];
new bool:g_menu[MAXPLAYERS];

new g_iAmmo;

new String:g_OnSnd[255]	= "items/ammocrate_open.wav";
new String:g_SelSnd[255] = "items/ammo_pickup.wav";

public OnPluginStart()
{	
	CreateConVar("dod_choosenade_ver", PLUGIN_VERSION, "DoD:S ChooseNade(DO NOT CHANGE!)", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	SetConVarString(FindConVar("dod_choosenade_ver"), PLUGIN_VERSION);

	HookEvent("player_spawn", Event_PlayerSpawn);
	RegConsoleCmd("cls_garand",Ch_Rifleman);
	RegConsoleCmd("cls_k98",Ch_Rifleman);
	HookEvent("dod_stats_weapon_attack",Event_DodStatsWeaponAttack);
	
	choosenade = CreateConVar("dod_choosenade_menu", "1", "<1/0> = enable/disable menu for rifleman class (default: 1)", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	choosesound = CreateConVar("dod_choosenade_sound", "1", "<1/0> = enable/disable sound when menu appears (default: 1)", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	choosebonus = CreateConVar("dod_choosenade_bonus", "0", "<0-2> = number of bonus nades (default: 0)", FCVAR_PLUGIN, true, 0.0, true, 2.0);
	choosetype = CreateConVar("dod_choosenade_type", "1", "<1/0> = 0: show menu each spawn - 1: first spawn after choosing rifleman (default: 1)", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	choosetime = CreateConVar("dod_choosenade_time", "0", "<#> = number of seconds menu will stay active - 0: permanent (default: 0)", FCVAR_PLUGIN, true, 0.0, true, 60.0);

	AutoExecConfig(true, "dod_choosenade_source", "dod_choosenade_source");
}

public OnMapStart()
{
	g_iAmmo = FindSendPropOffs("CDODPlayer", "m_iAmmo");
	
	if(GetConVarBool(choosenade))
	{
		if (GetConVarBool(choosesound))
		{
			PrecacheSound(g_OnSnd, true);
			PrecacheSound(g_SelSnd, true);
		}
	}
}

public OnClientPostAdminCheck(client)
{
	g_gren[client] = false;
	g_menu[client] = false;
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast) 
{
	if(GetEventInt(event,"userid")>0)
	{
		new client=GetClientOfUserId(GetEventInt(event,"userid"));
		if(GetConVarBool(choosenade) && ValidPlayer(client))
		{
			if(g_gren[client])
			{
				new bonus = GetConVarInt(choosebonus);
				new wpng = GetPlayerWeaponSlot(client, 3);
				if(wpng != -1)
				{
					decl String:wpnginslot[64];
					GetEdictClassname(wpng, wpnginslot, sizeof(wpnginslot));
					new Ammo = 0;
					if(strcmp("weapon_riflegren_us", wpnginslot, true) == 0)
					{
						Ammo = GetEntData(client, g_iAmmo + 84)+1;
						RemoveWeapon(client, wpng);
						GivePlayerItem(client, "weapon_frag_us");
						SetEntData(client, g_iAmmo + 52, Ammo+bonus, 4, true);
						if (GetConVarBool(choosesound))
							EmitSoundToClient(client, g_SelSnd, _, _, _, _, 1.0);
						g_gren[client] = true;
					}
					else if(strcmp("weapon_riflegren_ger", wpnginslot, true) == 0)
					{
						Ammo = GetEntData(client, g_iAmmo + 88)+1;
						RemoveWeapon(client, wpng);
						GivePlayerItem(client, "weapon_frag_ger");
						SetEntData(client, g_iAmmo + 56, Ammo+bonus, 4, true);
						if (GetConVarBool(choosesound))
							EmitSoundToClient(client, g_SelSnd, _, _, _, _, 1.0);
						g_gren[client] = true;
					}
				}
			}
			if (!GetConVarBool(choosetype) || g_menu[client])
				CreateTimer(0.5, GMenu, client, TIMER_FLAG_NO_MAPCHANGE);
		}
	}
}

public Event_DodStatsWeaponAttack(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client;
	client = GetClientOfUserId(GetEventInt(event, "attacker"));
	if(ValidPlayer(client,true))
	{
		//check if grenade
		new weapon = GetEventInt(event, "weapon");
		if (weapon == 19 || weapon == 20 || weapon == 25 || weapon == 26)
		{
			//remove menu
			new MenuSource:menu = GetClientMenu(client);
			if (menu != MenuSource_None)
			{
				CancelClientMenu(client,true);
				g_menu[client] = true;
			}
		}
	}
}

public Action:GMenu(Handle:timer, any:client)
{
	if(ValidPlayer(client,true))
	{
		new wpng = GetPlayerWeaponSlot(client, 3);
		if(wpng != -1)
		{	
			new wpn = GetPlayerWeaponSlot(client, 0);
			if(wpn != -1 && IsValidEdict(wpn))
			{
				decl String:wpninslot[64];
				GetEdictClassname(wpn, wpninslot, sizeof(wpninslot));
				if(strcmp("weapon_k98", wpninslot, true) == 0 || strcmp("weapon_garand", wpninslot, true) == 0)
				{
					decl String:wpnginslot[64];
					GetEdictClassname(wpng, wpnginslot, sizeof(wpnginslot));
					new bonus = GetConVarInt(choosebonus);
					
					new bool:grentype = true;
					new cgren = 0;
					
					if(strcmp("weapon_frag_us", wpnginslot, true) == 0)
						cgren = GetEntData(client, g_iAmmo + 52);
					else if(strcmp("weapon_frag_ger", wpnginslot, true) == 0)
						cgren = GetEntData(client, g_iAmmo + 56);
					else if(strcmp("weapon_riflegren_us", wpnginslot, true) == 0)
					{
						grentype = false;
						cgren = GetEntData(client, g_iAmmo + 84)+1;
					}
					else if(strcmp("weapon_riflegren_ger", wpnginslot, true) == 0)
					{
						grentype = false;
						cgren = GetEntData(client, g_iAmmo + 88)+1;
					}
					
					if (GetConVarBool(choosesound))
						EmitSoundToClient(client, g_OnSnd, _, _, _, _, 1.0);

					if(cgren == 0)
						bonus = 0;
						
					new Handle:GrenMenu=CreateMenu(GrenMenu_Select);
					decl String:t1[32], String:t2[32];
					SetMenuTitle(GrenMenu,"[Rifleman]\n \n");
					if(grentype)
					{
						Format(t1, sizeof(t1), "%d x Rifle grenades", cgren - bonus);
						Format(t2, sizeof(t2), "> %d x Grenades", cgren);
					}
					else
					{
						Format(t1, sizeof(t1), "> %d x Rifle grenades", cgren);
						Format(t2, sizeof(t2), "%d x Grenades", cgren + bonus);
					}
					AddMenuItem(GrenMenu,"0",t1);
					AddMenuItem(GrenMenu,"1",t2);
					SetMenuExitButton(GrenMenu,false);
					if(GetConVarInt(choosetime) == 0)
						DisplayMenu(GrenMenu,client,MENU_TIME_FOREVER);
					else
						DisplayMenu(GrenMenu,client,GetConVarInt(choosetime));
				}
			}
		}
	}
}

public GrenMenu_Select(Handle:menu,MenuAction:action,client,selection)
{
	if(action==MenuAction_Select)
	{
		if(ValidPlayer(client,true))
		{	
			new bonus = GetConVarInt(choosebonus);
			new wpng = GetPlayerWeaponSlot(client, 3);
			if(wpng != -1 && IsValidEdict(wpng))
			{
				decl String:wpnginslot[64];
				GetEdictClassname(wpng, wpnginslot, sizeof(wpnginslot));
				new Ammo = 0;
				switch(selection)
				{
					case 0:
					{
						g_gren[client] = false;
						g_menu[client] = false;
						
						if(strcmp("weapon_frag_us", wpnginslot, true) == 0)
						{
							Ammo = GetEntData(client, g_iAmmo + 52)-(bonus+1);
							RemoveWeapon(client, wpng);
							GivePlayerItem(client, "weapon_riflegren_us");
							if (Ammo > 0)
								SetEntData(client, g_iAmmo + 84, Ammo, 4, true);
							if (GetConVarBool(choosesound))
								EmitSoundToClient(client, g_SelSnd, _, _, _, _, 1.0);
						}
						else if(strcmp("weapon_frag_ger", wpnginslot, true) == 0)
						{
							Ammo = GetEntData(client, g_iAmmo + 56)-(bonus+1);
							RemoveWeapon(client, wpng);
							GivePlayerItem(client, "weapon_riflegren_ger");
							if (Ammo > 0)
								SetEntData(client, g_iAmmo + 88, Ammo, 4, true);
							if (GetConVarBool(choosesound))
								EmitSoundToClient(client, g_SelSnd, _, _, _, _, 1.0);
						}
					}
					case 1:
					{
						g_gren[client] = true;
						g_menu[client] = false;
						
						if(strcmp("weapon_riflegren_us", wpnginslot, true) == 0)
						{
							Ammo = GetEntData(client, g_iAmmo + 84)+1;
							RemoveWeapon(client, wpng);
							GivePlayerItem(client, "weapon_frag_us");
							SetEntData(client, g_iAmmo + 52, Ammo+bonus, 4, true);
							if (GetConVarBool(choosesound))
								EmitSoundToClient(client, g_SelSnd, _, _, _, _, 1.0);
						}
						else if(strcmp("weapon_riflegren_ger", wpnginslot, true) == 0)
						{
							Ammo = GetEntData(client, g_iAmmo + 88)+1;
							RemoveWeapon(client, wpng);
							GivePlayerItem(client, "weapon_frag_ger");
							SetEntData(client, g_iAmmo + 56, Ammo+bonus, 4, true);
							if (GetConVarBool(choosesound))
								EmitSoundToClient(client, g_SelSnd, _, _, _, _, 1.0);
						}
					}
				}
			}
		}
	}
}

public Action:Ch_Rifleman(client,args)
{
	g_menu[client] = true;
	return Plugin_Continue;
}

RemoveWeapon(client, iWeapon) {
	RemovePlayerItem(client, iWeapon);
	RemoveEdict(iWeapon);
}

stock bool:ValidPlayer(client,bool:check_alive=false){
	if(client>0 && client<=MaxClients && IsClientConnected(client) && IsClientInGame(client))
	{
		if(check_alive && !IsPlayerAlive(client))
		{
			return false;
		}
		return true;
	}
	return false;
}
	